

function [transx, transy, lam, exitflag]=boxcoxleo(x,y)
%Input and output are obvious.

         logL=@(h) -likbox(x,y,h);
         %[tr init1]=boxcox([y]);[tr init2]=boxcox([x]);
         %init=mean([init1 init2]); %derive a nice starting value.
         init=1;
         options=optimset('TolX',10^(-6), 'MaxIter', 20000, 'MaxFunEvals', 20000);
         [lam ,fval, exitflag]=fminsearch(logL,init,options);
         
         if exitflag~=1;init=-init;
             [lam, fval, exitflag]=fminsearch(logL,init,options);
         end
         
         if lam==0 %which is never going to happen
             transx=log(x);
             transy=log(y);
         else
             transx=((x.^lam)-1)./lam;
             transy=((y.^lam)-1)./lam;
         end
         
         
             
end

function [out]=likbox(x,y,h)

n=length(x);
m=length(y);
if h==0
    xh=log(x);
    yh=log(y);
else 
    xh=((x.^h)-1)./h;
    yh=((y.^h)-1)./h;
end

out= -n./2.*log(sum((xh-sum(xh)/n).^2)./n)  -m./2.*log(sum((yh-sum(yh)/m).^2)./m) +(h-1).*(sum(log(x))+sum(log(y)));

% -n./2.*log(sum((xh-sum(xh)/n).^2)./n)
% -m./2.*log(sum((yh-sum(yh)/m).^2)./m)
% +(h-1).*(sum(log(x))+sum(log(y)))
     

end

